'''
Created on Sep 30, 2013

@author: marten
'''
from sqlalchemy.orm.util import object_mapper

def _abstract_operator_tbs_listener(connection, target, tbs, accountant=False, accountant_privs=None):

    from basesoft.web.core.util.db import Session
    from pvcycle.core.models import PvcOperatorLicense
    session = Session()

    group_obj, backref = target.get_group_object()

    # Get the PvcOperatorLicense(s) within this domain
    operators = session.query(PvcOperatorLicense).filter(PvcOperatorLicense.domain==tbs.domain).all()
    for operator in operators:
        go = group_obj()
        values = {
            '%s_id' % backref: target.id,
            'group_id': operator.default_group.id,
            'privilege': target.PRIV_VIEW,
            'license_has_privilege': True
        }
        connection.execute(object_mapper(go).local_table.insert().values(**values))

    # add it to the TBS as well.
    go = group_obj()
    values = {
        '%s_id' % backref: target.id,
        'group_id': tbs.default_group.id,
        'privilege': target.PRIV_VIEW,
        'license_has_privilege': True
    }
    connection.execute(object_mapper(go).local_table.insert().values(**values))
    
    if not accountant:
        return

    if accountant_privs is None:
        accountant_privs = [target.PRIV_VIEW]

    for at in tbs.tbs_accountants:
        for priv in accountant_privs:
            go = group_obj()
            values = {
                '%s_id' % backref: target.id,
                'group_id': at.accountant.default_group.id,
                'privilege': priv,
                'license_has_privilege': True
            }
            connection.execute(object_mapper(go).local_table.insert().values(**values))

def tbs_member_file_listener(mapper, connection, target):
    _abstract_operator_tbs_listener(connection, target, target.tbs_member.tbs)

