# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.
from django.utils.translation import ugettext_lazy as _

from basesoft.util.ordered_dict import OrderedDict
from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController

from iqportal.iqreport.core.controllers import DashboardDynamicTableController

class PvcLogisticsPickupGraphWidget(DashboardDynamicTableController):
    """
    Simple dynamic table based widget
    """
    label = _('Pickup request status (graph)')
    name = 'pvc_logistics_pickup_graph_widget'
    category = _('PVC Logistics')
    permissions = ['pvc_logistics', 'pvc_logistics_key_user']

class PvcLogisticsDeliveryGraphWidget(DashboardDynamicTableController):
    """
    Simple dynamic table based widget
    """
    label = _('Delivery request status (graph)')
    name = 'pvc_logistics_delivery_graph_widget'
    category = _('PVC Logistics')
    permissions = ['pvc_logistics', 'pvc_logistics_key_user']

class PvcPickupRequestOverviewWidget(DashboardWidgetCQStateController):
    label = _('Pickup request overview')
    name = 'pvc_pickup_request_widget'
    category = _('PVC Logistics')
    permissions = ['pvc_logistics_key_user', 'pvc_logistics_holder']

    def has_permissions(self, controller):
        return controller.has_any_permissions(*self.permissions)

class PvcDeliveryRequestOverviewWidget(DashboardWidgetCQStateController):
    label = _('Delivery request overview')
    name = 'pvc_delivery_request_widget'
    category = _('PVC Logistics')
    permissions = ['pvc_logistics_key_user', 'pvc_logistics_carrier']

    def has_permissions(self, controller):
        return controller.has_any_permissions(*self.permissions)

widgets_mapper = OrderedDict([
    ('PvcLogisticsDeliveryGraphWidget', PvcLogisticsDeliveryGraphWidget, ),
    ('PvcLogisticsPickupGraphWidget', PvcLogisticsPickupGraphWidget, ),
    ('PvcDeliveryRequestOverviewWidget', PvcDeliveryRequestOverviewWidget, ),
    ('PvcPickupRequestOverviewWidget', PvcPickupRequestOverviewWidget, ),
])
