# Copyright (c) 2014 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.mailing.controllers import MailBaseController
from basesoft.web.contrib.account.mailing import AbstractAccountMailStateController

from pvcycle.order.models import PvcDeclarationReminderMail

class PvcDeclarationReminderMailStateController(AbstractAccountMailStateController):

    _instance_class = PvcDeclarationReminderMail

    # permissions needed for using this kind of mail
    CREATE_ACCESS_PERMISSIONS   = ['pvc_manage_declaration_mail']
    VIEW_ACCESS_PERMISSIONS     = ['pvc_manage_declaration_mail']
    UPDATE_ACCESS_PERMISSIONS   = ['pvc_manage_declaration_mail']
    DELETE_ACCESS_PERMISSIONS   = ['pvc_manage_declaration_mail']
    SCHEDULE_ACCESS_PERMISSIONS = []



class MailController(MailBaseController):
    """
    Class that's on top of the MailBaseController. This is used for
    handling PvcSubrogationRejectionMail objects.
    """
    _state_controllers = {
        'PvcDeclarationReminderMail': PvcDeclarationReminderMailStateController,
    }
