# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.
from django.utils.translation import ugettext_lazy as _

from basesoft.util.ordered_dict import OrderedDict
from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController


class PvcTbsProductOverviewWidget(DashboardWidgetCQStateController):
    """
    Tbs product overview
    """
    label = _('TBS product overview')
    name = 'pvc_db_tbs_product_overview_widget'
    icon = ''
    category = _('PVC Product')
    permissions = ['manage_pvc_product_levels']


class TbsMemberProductOverviewWidget(DashboardWidgetCQStateController):
    """
    Tbs member product overview
    """
    label = _('Product overview')
    name = 'pvc_db_tbs_member_product_overview_widget'
    icon = ''
    category = _('PVC Product')
    permissions = ['pvc_member_license', 'pvc_tbs_member_manager'] # OR

    def has_permissions(self, controller):
        # Operator should be able to place this on dashboard for member
        return controller.has_any_permissions(*self.permissions)


widgets_mapper = OrderedDict([
    ('PvcTbsProductOverviewWidget', PvcTbsProductOverviewWidget, ),
    ('TbsMemberProductOverviewWidget', TbsMemberProductOverviewWidget, ),
])