# Copyright (c) 2013 BaseSoft B.V.
# See LICENSE for details.
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController
from basesoft.util.ordered_dict import OrderedDict

class PVCPVModuleOverviewWidget(DashboardWidgetCQStateController):
    label = _('PV module manager')
    name = 'pvc_db_pv_module_overview_widget'
    category = _('PVC Declaration')
    permissions = ['pvc_manage_pv_modules']

class PVCPVModuleImportWidget(DashboardWidgetCQStateController):
    label = _('PV module import manager')
    name = 'pvc_db_pv_module_import_widget'
    category = _('PVC Declaration')
    permissions = ['pvc_import_pv_modules', 'pvc_version_1_access']

class PVModuleCountryWidget(DashboardWidgetCQStateController):
    label = _('PV module per country')
    name = 'pvc_db_pv_module_country_widget'
    category = _('PVC Declaration')
    permissions = ['pvc_select_pv_modules', 'pvc_manage_pv_modules']

    def has_permissions(self, controller):
        if not controller.has_any_permissions('pvc_version_1_access'):
            return False
        return controller.has_any_permissions(*self.permissions)

widgets_mapper = OrderedDict([
    ('PVCPVModuleOverviewWidget', PVCPVModuleOverviewWidget, ),
    ('PVCPVModuleImportWidget', PVCPVModuleImportWidget),
    ('PVModuleCountryWidget', PVModuleCountryWidget),
])
