'''
Created on Aug 26, 2013

@author: marten
'''
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from pvcycle.core.icons import AbstractPvcIcon

class PvcPVModuleManagerIcon(AbstractPvcIcon):

    id = 'icon-pvc-pv-module-manager'
    title = _('PV module manager')
    component = 'pvc_pv_module_manager'
    icon_index = 70
    group = 'pvc_pv_module'
    colorname = 'iconbar-java'

    char_main = u'\uE80a'
    char_sub = u'\uE806'

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('pvc_manage_pv_modules')
        self._assert_pvc_license(controller)

class PvcPVModuleSelectIcon(AbstractPvcIcon):

    id = 'icon-pvc-pv-module-select'
    title = _('PV module select')
    component = 'pvc_pv_module_select'
    icon_index = 72
    group = 'pvc_pv_module'
    colorname = 'iconbar-java'

    char_main = u'\uE80a'
    char_sub = u'\uE80b'

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('pvc_select_pv_modules', 'pvc_version_1_access')
        self._assert_pvc_license(controller)

class PvcPVModuleCountryManagerIcon(AbstractPvcIcon):

    id = 'icon-pvc-pv-module-country-manager'
    title = _('PV module per country')
    component = 'pvc_pv_module_country_manager'
    icon_index = 71
    group = 'pvc_pv_module'
    colorname = 'iconbar-java'

    char_main = u'\uE800'
    char_sub = u'\uE80a'

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('pvc_select_pv_modules', 'pvc_version_1_access')
        self._assert_pvc_license(controller)

class PvcPVModuleImportManagerIcon(AbstractPvcIcon):
    id = 'icon-pvc-pv-module-import-manager'
    title = _('PV module import manager')
    component = 'pvc_pv_module_import_manager'
    icon_index = 74
    group = 'pvc_pv_module'
    colorname = 'iconbar-java'

    char_main = u'\uE80a' # Suitcase icon
    char_sub = u'\uE818' # Arrow left icon

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('pvc_import_pv_modules', 'pvc_version_1_access')
        self._assert_pvc_license(controller)

class PvcPVModuleDeclarationManagerIcon(AbstractPvcIcon):
    id = 'icon-pvc-pv-module-import-manager'
    title = _('PV Module vs. declaration overview')
    component = 'pvc_pv_module_declaration_manager'
    icon_index = 74
    group = 'pvc_pv_module'
    colorname = 'iconbar-java'

    char_main = u'\uE80a' # Suitcase icon
    char_sub = u'\uE802' # TODO: fixme ;)

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('pvc_manage_pv_modules', 'pvc_view_declarations')
        self._assert_pvc_license(controller)

def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """

    return [
        PvcPVModuleManagerIcon(),
        PvcPVModuleSelectIcon(),
        PvcPVModuleCountryManagerIcon(),
        PvcPVModuleImportManagerIcon(),
        PvcPVModuleDeclarationManagerIcon()
    ]
