'''
Created on Dec 4, 2013

@author: marten
'''
from sqlalchemy import and_

from basesoft.scheduler.task import ScheduleTask
from basesoft.web.contrib.file.models import ImportFile, ImportFileType
from basesoft.web.contrib.file.controllers import ImportFileController

from pvcycle.pvmodule.controllers import PvcPVModuleController

class ImportPVModuleTask(ScheduleTask):
    """
    @deprecated with PV CYCLE 2.0
    """

    # Can only be triggered from the interface
    INTERVAL = 0

    def execute(self):
        """
        Imports contacts from large files saved in ImportFile
        """
        results = self.sa_session.query(ImportFile).join(ImportFileType).filter(and_(
                    ImportFileType.name=='pvcycle.pvmodule',
                    ImportFile.status==ImportFile.STATUS_NEW,
                    ImportFile.deleted==False,
                    ImportFile.archived==False)).all()

        if len(results) == 0:
            return

        for _file in results:
            _file.status = ImportFile.STATUS_STARTED
            self.sa_session.add(_file)
        self.sa_session.flush()

        pc = PvcPVModuleController(self.sa_session)
        impc = ImportFileController(self.sa_session)

        for _file in results:
            try:
                _modules, failure_file = pc.import_pv_modules(_file, dryrun=False)
                impc.set_data(_file, ImportFile.STATUS_SUCCESS, len(_modules), failure_file)
            except Exception, e:
                impc.set_data(_file, ImportFile.STATUS_FAILURE, e.message)
                raise

class DisablePVModuleTask(ScheduleTask):
    """
    @deprecated with PV CYCLE 2.0
    """
    # Can only be triggered from the interface
    INTERVAL = 0
    QUEUE_IF_EXISTS = True # in case they trigger it again it needs to be redone after completion

    def execute(self):
        pc = PvcPVModuleController(self.sa_session)
        pc.disable_pv_modules_for_all_non_eu_countries()




