# Copyright (c) 2014 BaseSoft B.V.
# See LICENSE for details.
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController
from basesoft.util.ordered_dict import OrderedDict

class PVCHistoricalDataOverviewWidget(DashboardWidgetCQStateController):
    label = _('Historical data')
    name = 'pvc_db_historical_data_widget'
    category = _('PVC Declaration')
    permissions = ['pvc_manage_historical_data', 'pvc_create_historical_data']

    def has_permissions(self, controller):
        # Operator should be able to place this on dashboard for member
        return controller.has_any_permissions(*self.permissions)

widgets_mapper = OrderedDict([
    ('PVCHistoricalDataOverviewWidget', PVCHistoricalDataOverviewWidget, ),
])
