# Copyright (c) 2014 BaseSoft B.V.
# See LICENSE for details.
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from pvcycle.core.icons import AbstractPvcIcon

class PvcHistoricalDataManagerIcon(AbstractPvcIcon):

    id = 'icon-pvc-historical-data-manager'
    title = _('Historical data manager')
    component = 'pvc_historical_data_manager'
    icon_index = 70
    group = 'pvc_report'
    group_title = _('PVC Report')
    colorname = 'iconbar-malachite'

    char_main = u'\uE836' # Clock icon
    char_sub = u'\uE847' # Arrow back icon

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_any_permissions('pvc_manage_historical_data', 'pvc_create_historical_data')
        self._assert_pvc_license(controller)

def get_icons():
    """
    return the list of icons that the report app adds to the iconbar
    """

    return [PvcHistoricalDataManagerIcon(),]