# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

"""
Settings for the PVCYCLE project
"""

import time, sys
from pvcycle.settings.debug import *
from basesoft.settings.ian import *
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities

DEBUG = True
TEMPLATE_DEBUG = DEBUG

YUI_DEBUG_FILES = True

BASE_URL = 'http://192.168.8.75:8000/'

#DATABASE_ENGINE = ''           # 'postgresql_psycopg2', 'postgresql', 'mysql', 'sqlite3' or 'oracle'.
#DATABASE_NAME = ''             # Or path to database file if using sqlite3.
#DATABASE_USER = ''             # Not used with sqlite3.
#DATABASE_PASSWORD = ''         # Not used with sqlite3.
#DATABASE_HOST = ''             # Set to empty string for localhost. Not used with sqlite3.
#DATABASE_PORT = ''             # Set to empty string for default. Not used with sqlite3.

#SCHEDULER_TWISTD = '/opt/local/bin/twistd-2.6'

DB_CONNSTR = 'mysql://root:root@127.0.0.1:3306/pvcycle?charset=utf8'
#DB_CONNSTR = 'mysql://root:basesoft@marten.dev.ams:3306/iqportal'
#DB_CONNSTR_FOODMART = 'mysql://foodmart:foodmart@nestorix.office.basesoft.com:3306/foodmart'
#DB_CONNSTR_WEEEBLACKBOX = 'mysql://root:basesoft@127.0.0.1:3306/IQ_ELC_MARTEN_STBL'

DB_CONNSTR_READONLY = DB_CONNSTR

MONDRIAN_XMLA_SERVER = ('localhost', 8080)
MONDRIAN_XMLA_PATH = '/iqube-ian-pvcycle/xmla'
IQUBE_SERVLET = "http://localhost:8080/iqube-ian-pvcycle/IQubeXmlRpcServlet"

MONDRIAN_XMLA_CACHE_ENABLED = False

#SELENIUM_DJANGO_ADDR = '192.168.8.75:8010'
SELENIUM_DJANGO_ADDR = '0.0.0.0:8000'

EMAIL_HOST = 'basesoft-fs.office'

'''
Call function to start selenium test

local: [True|False]
    True    : start selenium test on local machine
    False   : start selenium test on VM

Browser: [ff|ie|gc]
    ff : use firefox browser
    ie : use internet explorer browser (only available if local is set to VM)
    gc : use chrome browser

start_django: [True|False]
    True : start django with start of test
    False : start without django

start_scheduler: [True|False]
    True : start scheduler
    False : no scheduler

remote: [True|False]
    True : start remote test on buildbot machine
    False : no remote test on buildbot machine

SELENIUM = selenium_start(local, browser, start_django, start_scheduler, remote)
'''
SELENIUM = selenium_start(local=True, browser='gc', start_django=False, start_scheduler=False, remote=False)

SERVE_STATIC_MEDIA = True

# pvcycle export apps
zBASE_APPS = [
'basesoft.web.core',
'basesoft.web.contrib.dashboard',
'basesoft.web.contrib.session',
'basesoft.web.contrib.i18n',
'basesoft.web.contrib.file',
'basesoft.web.contrib.contact',
'basesoft.web.contrib.license',
'basesoft.web.contrib.mailing',
'basesoft.web.contrib.account',
'basesoft.web.contrib.notification',
'basesoft.web.contrib.compose',
'basesoft.web.contrib.order',
'basesoft.web.contrib.basesoft',
'basesoft.web.contrib.branding',
'basesoft.web.contrib.theme',
'basesoft.web.contrib.ticketing',
'basesoft.web.contrib.wiki',
'basesoft.web.contrib.home',
]

INSTALLED_APPS = BASE_APPS + IQUBE_APPS + IQREPORT_APPS + PVCYCLE_APPS
add_test_apps(INSTALLED_APPS)

STATIC_SQUASHED_ROOT = '/home/ian/static'

# Allow any remote addr to be in admin ips
MIDDLEWARE_CLASSES.append('basesoft.web.middleware.dev.RemoteAddrToInternalIp')
#NODEJS_SERVER = 'http://192.168.8.127:8081'

#WKHTMLTOPDF_BIN = "/Applications/wkhtmltopdf/Contents/MacOS/wkhtmltopdf"

#import os
#if os.uname()[0] == 'Darwin':
FONTS_PATH = None #'/Users/ian/workspace/fonts/'
#LOGGER_SYSLOG_ADDRESS = '/var/run/syslog'

ORDER_OGONE_POST = "%sbasesoft.web.test/selenium/order/ogone_payment_accept/" % BASE_URL

SITE_NAME = False

# below is for running the tests from eclipse
if __name__ == '__main__':

    from twisted.scripts.trial import run
    import sys
    import os
    os.environ['DJANGO_SETTINGS_MODULE'] = 'pvcycle.settings.ian'
    sys.argv = ['test_member.py', 'pvcycle.test.selenium.test_tbs.TestCase.test_certificate']
    run()
    sys.exit()
