# Copyright (c) 2014 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController
from basesoft.util.ordered_dict import OrderedDict

class PVCSubrogationOverviewWidget(DashboardWidgetCQStateController):
    label = _('Subrogation manager')
    name = 'pvc_db_subrogation_widget'
    category = _('PVC Subrogation')
    permissions = ['pvc_request_for_subrogation', 'pvc_manage_subrogations'] # OR

    def has_permissions(self, controller):
        # Operator/TBS as well as the member
        return controller.has_any_permissions(*self.permissions)

widgets_mapper = OrderedDict([
    ('PVCSubrogationOverviewWidget', PVCSubrogationOverviewWidget, ),
])
