# Copyright (c) 2014 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.mailing.controllers import MailBaseController
from basesoft.web.contrib.account.mailing import AbstractAccountMailStateController

from pvcycle.subrogation.models import PvcSubrogationRejectionMail, PvcSubrogationSubrogatorMandateMail,\
    PvcSubrogationCommissionerMandateMail

class AbstractSubrogationMailStateController(AbstractAccountMailStateController):

    # permissions needed for using this kind of mail
    CREATE_ACCESS_PERMISSIONS   = ['pvc_manage_subrogation_mail']
    VIEW_ACCESS_PERMISSIONS     = ['pvc_manage_subrogation_mail']
    UPDATE_ACCESS_PERMISSIONS   = ['pvc_manage_subrogation_mail']
    DELETE_ACCESS_PERMISSIONS   = ['pvc_manage_subrogation_mail']
    SCHEDULE_ACCESS_PERMISSIONS = []

class SubrogationRejectMailStateController(AbstractSubrogationMailStateController):
    _instance_class = PvcSubrogationRejectionMail

class SubrogationSubrogatorMandateMailStateController(AbstractSubrogationMailStateController):
    _instance_class = PvcSubrogationSubrogatorMandateMail

class SubrogationCommissionerMandateMailStateController(AbstractSubrogationMailStateController):
    _instance_class = PvcSubrogationCommissionerMandateMail

class MailController(MailBaseController):
    """
    Class that's on top of the MailBaseController. This is used for
    handling PvcSubrogationRejectionMail objects.
    """
    # mapping between object type and the controller
    _state_controllers = {
        'PvcSubrogationRejectionMail': SubrogationRejectMailStateController,
        'PvcSubrogationSubrogatorMandateMail': SubrogationSubrogatorMandateMailStateController,
        'PvcSubrogationCommissionerMandateMail': SubrogationCommissionerMandateMailStateController,
    }