'''
Created on Sep 18, 2013

@author: marten
'''

from django.conf import settings

from basesoft.web.test.selenium.selenium_testcase import SeleniumTestCase
from pvcycle.test.unit.pvc_unittest import PvcTestCase

class PvcSeleniumTestCase(SeleniumTestCase, PvcTestCase):


    def login(self, account, password, language='en_GB'):
        """
        Override these methods as we do not have an icon bar on the home page for PV CYCLE.
        """

        # logout first
        self.clear_cookies()

        # open homepage
        self._driver.get(settings.SELENIUM['browserURL']);

        self.wait_for_loading()

        self.fill_form(form_name='pvcycle-home-login-form', values={
            'username': account,
            'password': password
        });

        self.click_button(form_name='login-button-form', text='Login')
        self.wait_for_loading(stable_time=5)
