'''
Created on Nov 13, 2013

@author: marten
'''
from basesoft.web.core.util.controllers import AbstractController
from basesoft.web.core.exceptions import PublicUserException

from pvcycle.core.controllers import AbstractPvcController
from pvcycle.order.controllers import PvcDeclarationOrderController,\
    PvcOrderController

class PvcUserAcceptanceTestingController(AbstractController, AbstractPvcController):
    def trigger_new_declarations(self):
        tbss = self._get_take_back_schemes(None)
        if len(tbss) == 0:
            raise PublicUserException('No access to any Take Back Schemes.')

        dc = PvcDeclarationOrderController(self.sa_session)

        cnt = 0
        for tbs in tbss:
            tc = dc.trigger_new_declarations(tbs)
            if tc is not None:
                cnt += len(tc)

        return cnt

    def trigger_close_declarations(self):
        tbss = self._get_take_back_schemes(None)
        if len(tbss) == 0:
            raise PublicUserException('No access to any Take Back Schemes.')

        dc = PvcDeclarationOrderController(self.sa_session)

        cnt = 0
        ncd = []
        for tbs in tbss:
            tc = dc.close_declarations(tbs)
            if tc is None:
                ncd.append(tbs.name)
                continue
            cnt += len(tc)

        return {'closed': cnt, 'not_closing_date': ncd}

    def trigger_yearly_af_fee(self):
        tbss = self._get_take_back_schemes(None)
        if len(tbss) == 0:
            raise PublicUserException('No access to any Take Back Schemes.')

        cnt = 0

        for tbs in tbss:
            oc = PvcOrderController(self.sa_session)
            if oc.trigger_yearly_administrative_fees(tbs):
                cnt += 1

        return cnt

